﻿@using Models.Avisos

@inject IModalService Modal

<ToastComponent @ref="Notificacion"></ToastComponent>

<CardComponent Title="Mantenimiento Avisos" WithMaxHeight="false">

    @if (ViewModel?.AvisosList == null)
    {
        <p><em>Loading...</em></p>
    }
    else
    {

        <div class="my-md-3">
            <SfGrid @ref="@Grid" ID="Grid" TValue="AvisoBase" DataSource="@ViewModel.AvisosList" AllowSelection="true" AllowSorting="true" AllowPaging="true" ColumnMenuItems=@MenuItems Toolbar="@(new string[] { "Add","Search", "ExcelExport" })" AllowExcelExport="true" GridLines="GridLine.Both" Height="100%">
                <GridEditSettings AllowEditing="true" AllowAdding="true" NewRowPosition="NewRowPosition.Bottom"></GridEditSettings>
                <GridFilterSettings Columns="@FilterCols"></GridFilterSettings>
                <GridSearchSettings Fields="@SearchCols" IgnoreAccent="true" IgnoreCase="true" Operator="Operator.Contains"></GridSearchSettings>
                <GridEvents OnActionBegin="OnActionBegin" OnToolbarClick="ToolbarClick" TValue="AvisoBase"></GridEvents>
                <GridPageSettings PageSize="10"></GridPageSettings>
                <GridColumns>
                    <GridColumn Field=@nameof(AvisoBase.Id) HeaderText="Id" IsPrimaryKey="true" IsIdentity="true" HideAtMedia="(min-width: 70px)" Width="70" TextAlign="TextAlign.Right"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.Titulo) HeaderText="Título"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.Categoria) HeaderText="Categoría"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.Tipo) HeaderText="Tipo"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.FechaCreacion) HeaderText="F.Creación" Format="g" Type="ColumnType.DateTime"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.FechaDesde) HeaderText="F.Desde" Format="g" Type="ColumnType.DateTime"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.FechaHasta) HeaderText="F.Hasta" Format="g" Type="ColumnType.DateTime"></GridColumn>
                    <GridColumn Field=@nameof(AvisoBase.Activo) HeaderText="Activo" DisplayAsCheckBox="true" TextAlign="TextAlign.Center" EditType="EditType.BooleanEdit"></GridColumn>
                    <GridColumn MinWidth="10" Width="150">
                        <Template>
                            @{
                                var aviso = (context as AvisoBase);
                                <div class="text-center">
                                    <span class="e-control e-btn e-lib e-outline e-primary btnCommand" @onclick="@(() => OnOption("Consultar", aviso))" title="Consultar"><img src="./Images/iconos/visibility.svg" class="btnCommand-img" /></span>
                                    <span class="e-control e-btn e-lib e-outline e-primary btnCommand" @onclick="@(() => OnOption("Duplicar", aviso))" title="Duplicar"><img src="./Images/iconos/duplicate.svg" class="btnCommand-img" /></span>
                                    <span class="e-control e-btn e-lib e-outline e-primary btnCommand" @onclick="@(() => OnOption("Activar/Desactivar", aviso))" title="Activar/Desactivar"><img src="./Images/iconos/square-with-verification-sign.svg" class="btnCommand-img" /></span>
                                </div>
                            }
                        </Template>
                    </GridColumn>
                </GridColumns>
            </SfGrid>
        </div>

    }

</CardComponent>

@code {
    [CascadingParameter(Name = "ViewModel")]
    IAvisoViewModel ViewModel { get; set; }

    void SetToDoItem(int id)
    {
        ViewModel.SetItem(id);
    }

    void DuplicateItem(int id)
    {
        ViewModel.DuplicateItem(id);
    }

    void ChangeStateItem(int id, bool state)
    {
        ViewModel.ChangeStateItem(id, state);
    }

    #region GridEvents
    private ToastComponent Notificacion;
    private SfGrid<AvisoBase> Grid;
    public string[] MenuItems = new string[] { "Filter" };
    private List<GridFilterColumn> FilterCols = new List<GridFilterColumn>();
    private string[] SearchCols = new string[] { "Titulo", "Categoria", "Tipo" };

    private void ToolbarClick(Syncfusion.Blazor.Navigations.ClickEventArgs args)
    {
        if (args.Item.Id == "Grid_excelexport")
        {
            this.Grid.ExcelExport();
        }
    }

    private void OnOption(string option, AvisoBase aviso)
    {
        switch (option)
        {
            case "Nuevo":
                SetToDoItem(0);
                ShowModal();
                break;
            case "Consultar":
                SetToDoItem(aviso.Id);
                ShowModal();
                break;
            case "Duplicar":
                DuplicateItem(aviso.Id);
                ShowModal();
                break;
            case "Activar/Desactivar":
                ChangeStateItem(aviso.Id, !aviso.Activo);
                this.Grid.Refresh();
                break;
        }

    }

    private void OnActionBegin(ActionEventArgs<AvisoBase> args)
    {
        if (args == null) return;

        if (args.RequestType == Syncfusion.Blazor.Grids.Action.BeginEdit)
        {
            args.Cancel = true;
            OnOption("Consultar", args.RowData);
        }
        else if (args.RequestType == Syncfusion.Blazor.Grids.Action.Add)
        {
            args.Cancel = true;
            OnOption("Nuevo", null);
        }

    }

    private void ActionFailureHandler(Syncfusion.Blazor.Grids.FailureEventArgs args)
    {
        this.Notificacion.ShowError(args.Error.ToString());
    }
    #endregion

    #region ModalEvents
    private void ShowModal()
    {
        var parameters = new ModalParameters();
        parameters.Add("Id", ViewModel.AvisoItem.Id);
        parameters.Add("ViewModel", ViewModel);

        var options = new ModalOptions() { DisableBackgroundCancel = true, HideHeader = true };

        Modal.OnClose -= ModalClosed;
        Modal.OnClose += ModalClosed;

        Modal.Show<ParamAviso>(string.Empty, parameters, options);
    }

    private void ModalClosed(ModalResult modalResult)
    {

        if (modalResult.Cancelled || modalResult.Data == null)
        {
            return;
        }

        this.Notificacion.ShowSuccess("Actualización correcta.", "El aviso se ha guardado correctamente.");

        this.Grid.Refresh();
        this.StateHasChanged();
    }
    #endregion
}

<style>
    .btnCommand-img {
        height: 14px;
        font-weight: bold;
    }

        .btnCommand-img:hover {
            filter: invert(1);
        }

    .btnCommand {
        color: black !important;
    }

        .btnCommand:hover {
            color: white !important;
        }
</style>
